<template>
    <Navbar />
    <SubNavbar />
    <div class="container">

        <h1><span style="color:yellow">▏</span> User</h1>
        <p>The admin is able to ban and restrict users who violate comments</p>

        <div class="table-list">
            <table style="margin-bottom: 10px;">
                <thead>
                    <tr>
                        <th style="width: 25%;">Username</th>
                        <th style="width: 25%">Email</th>
                        <th style="width: 10%">Role</th>
                        <th style="width: 20%">Report</th>
                        <th style="width: 20%">Action</th>
                    </tr>
                </thead>
            </table>

            <table>
                <tbody>
                    <tr v-for="user in dataResponse" :key="user.id">
                        <td style="width: 25%">{{ user.name }}</td>
                        <td style="width: 25%">{{ user.email }}</td>
                        <td style="width: 10%">{{ user.role || 'User' }}</td>
                        <td style="width: 20%">
                        <!-- Kolom Report, bisa diisi dengan konten sesuai kebutuhan -->
                        <button @click="reportUser(user.id)">Report</button>
                        </td>
                        <td style="width: 20%">
                        <button @click="restrictUser(user.id)">Restriction</button>
                        <button @click="banUser(user.id)">Ban</button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        
    </div>
  </template>
  
  <script>
  import Navbar from '@/components/Navbar.vue';
  import SubNavbar from '@/components/SubNavbar.vue';
  import axios from 'axios';
  import { ref } from 'vue';
  import { useRouter } from 'vue-router';
  
  export default {
    name: 'UserList',
    components: {
      Navbar, SubNavbar
    },
    setup() {
      const URL = 'http://localhost:8000';
      const dataResponse = ref([]);
      const router = useRouter()
  
      async function fetchDatas() {
        const token = window.localStorage.getItem('jwt-token')
       if(token){
        try {
          const response = await axios.get(`${URL}/api/listUser`,{
            headers : {
                Accept : 'application/json',
                Authorization : `Bearer ${token}`
            },

          });
          dataResponse.value = response.data.users;
        } catch (err) {
          console.error(err);
          router.push('/login')
        }
       }else{
        router.push('/login')
       }
      }
  
      fetchDatas();
  
      function reportUser(userId) {
        // Logika untuk melaporkan pengguna
        console.log(`Reporting user with ID: ${userId}`);
      }
  
      function restrictUser(userId) {
        // Logika untuk melakukan restrict pada pengguna
        console.log(`Restricting user with ID: ${userId}`);
      }
  
      function banUser(userId) {
        // Logika untuk melakukan ban pada pengguna
        console.log(`Banning user with ID: ${userId}`);
      }
  
      return {
        dataResponse,
        reportUser,
        restrictUser,
        banUser
      };
    }
  };
  </script>
  
  <style>
  body {
    background: #030814;
  }
  
  .container {
    color: white;
    padding: 20px;
  }
  
  table {
    width: 100%;
    border-collapse: collapse;
  }
  
  th, td {
    border: 1px solid #202938;
    padding: 8px;
    text-align: center;
    background-color: #111828;
  }
  
  .table-list {
    background-color: #202938;
    padding: 20px 30px;
    border-radius: 10px;
  }
  
  button {
    margin-right: 5px;
    padding: 5px 10px;
    background-color: #8A2E2E;
    color: white;
    border: none;
    border-radius: 5px;
    cursor: pointer;
  }
  
  button:hover {
    background-color: #202938;
  }
  </style>
  